import pytest


def test_001_disable_operated_client_channel_confirm_disabled_state_adml(admlc):

  # FIRST WE SET THE CLIENT ORIGIN HOST:
  requestBody = { "name":"afHost.afRealm.com" }
  responseBodyRef = { "success":"true", "response":"Forced node is now 'afHost.afRealm.com'" }

  # Send POST
  response = admlc.postDict("/node", requestBody)

  # Verify response
  admlc.assert_response__status_body_headers(response, 200, responseBodyRef)

  requestBodyHide = { "action":"hide" }
  requestBodyShown = { "action":"shown" }
  requestBodyHidden = { "action":"hidden" }

  responseBodyHideRef = { "success":"true", "response":"" }
  responseBodyTrueRef = { "success":"true", "response":"true" }
  responseBodyFalseRef = { "success":"true", "response":"false" }

  response = admlc.postDict("/visibility", requestBodyHide)
  admlc.assert_response__status_body_headers(response, 200, responseBodyHideRef)
  response = admlc.postDict("/visibility", requestBodyShown)
  admlc.assert_response__status_body_headers(response, 200, responseBodyFalseRef)
  response = admlc.postDict("/visibility", requestBodyHidden)
  admlc.assert_response__status_body_headers(response, 200, responseBodyTrueRef)

def test_002_enable_operated_client_channel_confirm_enabled_state_adml(admlc):

  # ENABLE (show) / DISABLE (hide) / CHECK (hidden/shown)
  requestBodyShow = { "action":"show" }
  requestBodyShown = { "action":"shown" }
  requestBodyHidden = { "action":"hidden" }

  responseBodyShowRef = { "success":"true", "response":"" }
  responseBodyTrueRef = { "success":"true", "response":"true" }
  responseBodyFalseRef = { "success":"true", "response":"false" }

  response = admlc.postDict("/visibility", requestBodyShow)
  admlc.assert_response__status_body_headers(response, 200, responseBodyShowRef)
  response = admlc.postDict("/visibility", requestBodyShown)
  admlc.assert_response__status_body_headers(response, 200, responseBodyTrueRef)
  response = admlc.postDict("/visibility", requestBodyHidden)
  admlc.assert_response__status_body_headers(response, 200, responseBodyFalseRef)

