// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_codec_basetypes_OctetString_hpp
#define anna_diameter_codec_basetypes_OctetString_hpp


// Local
#include <anna/diameter/codec/basetypes/AvpData.hpp>


namespace anna {

namespace diameter {

namespace codec {

class Avp;

namespace basetypes {

/**
* Diameter OctetString container
*/
class OctetString : public AvpData {

  std::string a_value;


  // Mandatory for basic diameter type:
  void codeBasic(char* buffer, int &size) throw(anna::RuntimeException);
  void setPrintableString(const char * printableString) throw(anna::RuntimeException);

protected:

  void assertPrintable() const throw(anna::RuntimeException);

public:

  virtual ~OctetString() {;}

  // Class-specific ////////////////////////////////////////////////////////////////////////////////////
  //
  /**
  * Gets the OctetString value
  *
  * @return OctetString value
  */
  const std::string& getValue() const throw() { return a_value; }

  /**
  * Sets the OctetString value
  *
  * @param value OctetString value
  */
  void setValue(const std::string& value) throw() { a_value = value; }
  //
  //////////////////////////////////////////////////////////////////////////////////////////////////////


  // gets
  // virtual for Unknown format container
  virtual std::string getFormatName() const throw() { return "OctetString"; }
  virtual int getSize() const throw() { return a_value.size(); }


  // helpers

  // sets

  void decode(const char* buffer, const int size) throw(anna::RuntimeException);
};

}
}
}
}

#endif
