// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_timex_internal_TickConsumer_hpp
#define anna_timex_internal_TickConsumer_hpp

#include <anna/comm/Handler.hpp>

namespace anna {

namespace comm {
class Communicator;
class SchedulerGuard;
}

namespace timex {

class Engine;

class TickConsumer : public comm::Handler {
public:
  TickConsumer(Engine* timeController) :
    comm::Handler(comm::Handler::Type::Custom, Support::None),
    a_timeController(*timeController) {
    a_pipe [0] = a_pipe [1] = -1;
  }

  int getfdWrite() const throw() { return a_pipe [1]; }

  std::string asString() const throw();

private:
  Engine& a_timeController;
  int a_pipe [2];

  void initialize() throw(RuntimeException);
  void apply() throw(RuntimeException);
  void finalize() throw();
  void clone() throw(RuntimeException);
};

}
}

#endif



